// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { CommandHandler } from "../../../../../../core/decorator/CommandHandlerDecorator";
import AccountService from "../../../../../service/account/AccountService";
import SecurityService from "../../../../../service/security/SecurityService";
import { IssueCommand, IssueCommandResponse } from "./IssueCommand";
import TransactionService from "../../../../../service/transaction/TransactionService";
import { lazyInject } from "../../../../../../core/decorator/LazyInjectDecorator";
import BigDecimal from "../../../../../../domain/context/shared/BigDecimal";
import ValidationService from "../../../../../service/validation/ValidationService";
import { SecurityRole } from "../../../../../../domain/context/security/SecurityRole";
import ContractService from "../../../../../service/contract/ContractService";
import { IssueCommandError } from "./error/IssueCommandError";
import { KycStatus } from "../../../../../../domain/context/kyc/Kyc";
let IssueCommandHandler = class IssueCommandHandler {
    securityService;
    accountService;
    transactionService;
    validationService;
    contractService;
    constructor(securityService, accountService, transactionService, validationService, contractService) {
        this.securityService = securityService;
        this.accountService = accountService;
        this.transactionService = transactionService;
        this.validationService = validationService;
        this.contractService = contractService;
    }
    async execute(command) {
        try {
            const { securityId, targetId, amount } = command;
            const handler = this.transactionService.getHandler();
            const security = await this.securityService.get(securityId);
            const account = this.accountService.getCurrentAccount();
            const securityEvmAddress = await this.contractService.getContractEvmAddress(securityId);
            const targetEvmAddress = await this.accountService.getAccountEvmAddress(targetId);
            const amountBd = BigDecimal.fromString(amount, security.decimals);
            await this.validationService.checkDecimals(security, amount);
            await this.validationService.checkPause(securityId);
            await this.validationService.checkMaxSupply(securityId, amountBd, security);
            await this.validationService.checkControlList(securityId, targetEvmAddress.toString());
            await this.validationService.checkKycAddresses(securityId, [targetId], KycStatus.GRANTED);
            await this.validationService.checkAnyRole([SecurityRole._ISSUER_ROLE, SecurityRole._AGENT_ROLE], account.id.toString(), securityId);
            await this.validationService.checkMultiPartition(security);
            await this.validationService.checkIssuable(security);
            // Check that the amount to issue + total supply is not greater than max supply
            const res = await handler.issue(securityEvmAddress, targetEvmAddress, amountBd, securityId);
            return Promise.resolve(new IssueCommandResponse(res.error === undefined, res.id));
        }
        catch (error) {
            throw new IssueCommandError(error);
        }
    }
};
IssueCommandHandler = __decorate([
    CommandHandler(IssueCommand),
    __param(0, lazyInject(SecurityService)),
    __param(1, lazyInject(AccountService)),
    __param(2, lazyInject(TransactionService)),
    __param(3, lazyInject(ValidationService)),
    __param(4, lazyInject(ContractService)),
    __metadata("design:paramtypes", [SecurityService,
        AccountService,
        TransactionService,
        ValidationService,
        ContractService])
], IssueCommandHandler);
export { IssueCommandHandler };
